<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex25.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex25.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex25.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex25.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 25: Even More Practice</h1>
                <p>We're going to do some more practice involving functions and variables to make sure you know them well.  This exercise should be straightforward for you to type in, break down, and understand.</p>
<p>However, this exercise is a little different.  You won't be running it.  Instead <em>you</em> will import it into Python and run the functions yourself.</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex25.py-idio.html-1"></a><span class="k">def</span> <span class="nf">break_words</span><span class="p">(</span><span class="n">stuff</span><span class="p">):</span>
<a name="python--ex25.py-idio.html-2"></a>    <span class="sd">&quot;&quot;&quot;This function will break up words for us.&quot;&quot;&quot;</span>
<a name="python--ex25.py-idio.html-3"></a>    <span class="n">words</span> <span class="o">=</span> <span class="n">stuff</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39; &#39;</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-4"></a>    <span class="k">return</span> <span class="n">words</span>
<a name="python--ex25.py-idio.html-5"></a>
<a name="python--ex25.py-idio.html-6"></a><span class="k">def</span> <span class="nf">sort_words</span><span class="p">(</span><span class="n">words</span><span class="p">):</span>
<a name="python--ex25.py-idio.html-7"></a>    <span class="sd">&quot;&quot;&quot;Sorts the words.&quot;&quot;&quot;</span>
<a name="python--ex25.py-idio.html-8"></a>    <span class="k">return</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-9"></a>
<a name="python--ex25.py-idio.html-10"></a><span class="k">def</span> <span class="nf">print_first_word</span><span class="p">(</span><span class="n">words</span><span class="p">):</span>
<a name="python--ex25.py-idio.html-11"></a>    <span class="sd">&quot;&quot;&quot;Prints the first word after popping it off.&quot;&quot;&quot;</span>
<a name="python--ex25.py-idio.html-12"></a>    <span class="n">word</span> <span class="o">=</span> <span class="n">words</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-13"></a>    <span class="k">print</span> <span class="n">word</span>
<a name="python--ex25.py-idio.html-14"></a>
<a name="python--ex25.py-idio.html-15"></a><span class="k">def</span> <span class="nf">print_last_word</span><span class="p">(</span><span class="n">words</span><span class="p">):</span>
<a name="python--ex25.py-idio.html-16"></a>    <span class="sd">&quot;&quot;&quot;Prints the last word after popping it off.&quot;&quot;&quot;</span>
<a name="python--ex25.py-idio.html-17"></a>    <span class="n">word</span> <span class="o">=</span> <span class="n">words</span><span class="o">.</span><span class="n">pop</span><span class="p">(</span><span class="o">-</span><span class="mi">1</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-18"></a>    <span class="k">print</span> <span class="n">word</span>
<a name="python--ex25.py-idio.html-19"></a>
<a name="python--ex25.py-idio.html-20"></a><span class="k">def</span> <span class="nf">sort_sentence</span><span class="p">(</span><span class="n">sentence</span><span class="p">):</span>
<a name="python--ex25.py-idio.html-21"></a>    <span class="sd">&quot;&quot;&quot;Takes in a full sentence and returns the sorted words.&quot;&quot;&quot;</span>
<a name="python--ex25.py-idio.html-22"></a>    <span class="n">words</span> <span class="o">=</span> <span class="n">break_words</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-23"></a>    <span class="k">return</span> <span class="n">sort_words</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-24"></a>
<a name="python--ex25.py-idio.html-25"></a><span class="k">def</span> <span class="nf">print_first_and_last</span><span class="p">(</span><span class="n">sentence</span><span class="p">):</span>
<a name="python--ex25.py-idio.html-26"></a>    <span class="sd">&quot;&quot;&quot;Prints the first and last words of the sentence.&quot;&quot;&quot;</span>
<a name="python--ex25.py-idio.html-27"></a>    <span class="n">words</span> <span class="o">=</span> <span class="n">break_words</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-28"></a>    <span class="n">print_first_word</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-29"></a>    <span class="n">print_last_word</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-30"></a>
<a name="python--ex25.py-idio.html-31"></a><span class="k">def</span> <span class="nf">print_first_and_last_sorted</span><span class="p">(</span><span class="n">sentence</span><span class="p">):</span>
<a name="python--ex25.py-idio.html-32"></a>    <span class="sd">&quot;&quot;&quot;Sorts the words then prints the first and last one.&quot;&quot;&quot;</span>
<a name="python--ex25.py-idio.html-33"></a>    <span class="n">words</span> <span class="o">=</span> <span class="n">sort_sentence</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-34"></a>    <span class="n">print_first_word</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25.py-idio.html-35"></a>    <span class="n">print_last_word</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>First, run this with <tt class="docutils literal">python ex25.py</tt> to find any errors you have made.  Once you have found all of the errors you can and fixed them, you will then want to follow the <em>What You Should See</em> section to complete the exercise.</p>
<div class="section" id="what-you-should-see">
<h1>What You Should See</h1>
<p>In this exercise we're going to interact with your <tt class="docutils literal">ex25.py</tt> file inside the <tt class="docutils literal">python</tt> interpreter you used periodically to do calculations.  You run <tt class="docutils literal">python</tt> from the terminal like this:</p>
<pre class="literal-block">
$ python
Python 2.7.1 (r271:86832, Jun 16 2011, 16:59:05)
[GCC 4.2.1 (Based on Apple Inc. build 5658) (LLVM build 2335.15.00)] on darwin
Type &quot;help&quot;, &quot;copyright&quot;, &quot;credits&quot; or &quot;license&quot; for more information.
&gt;&gt;&gt;
</pre>
<p>Your output should look like mine, and after the <tt class="docutils literal">&gt;</tt> character (called the prompt) you can type Python code in and it will run immediately.  Using this I want you to type each of these lines of Python code into <tt class="docutils literal">python</tt> and see what it does:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex25_pycon.py-idio.html-1"></a><span class="kn">import</span> <span class="nn">ex25</span>
<a name="python--ex25_pycon.py-idio.html-2"></a><span class="n">sentence</span> <span class="o">=</span> <span class="s2">&quot;All good things come to those who wait.&quot;</span>
<a name="python--ex25_pycon.py-idio.html-3"></a><span class="n">words</span> <span class="o">=</span> <span class="n">ex25</span><span class="o">.</span><span class="n">break_words</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio.html-4"></a><span class="n">words</span>
<a name="python--ex25_pycon.py-idio.html-5"></a><span class="n">sorted_words</span> <span class="o">=</span> <span class="n">ex25</span><span class="o">.</span><span class="n">sort_words</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio.html-6"></a><span class="n">sorted_words</span>
<a name="python--ex25_pycon.py-idio.html-7"></a><span class="n">ex25</span><span class="o">.</span><span class="n">print_first_word</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio.html-8"></a><span class="n">ex25</span><span class="o">.</span><span class="n">print_last_word</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio.html-9"></a><span class="n">words</span>
<a name="python--ex25_pycon.py-idio.html-10"></a><span class="n">ex25</span><span class="o">.</span><span class="n">print_first_word</span><span class="p">(</span><span class="n">sorted_words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio.html-11"></a><span class="n">ex25</span><span class="o">.</span><span class="n">print_last_word</span><span class="p">(</span><span class="n">sorted_words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio.html-12"></a><span class="n">sorted_words</span>
<a name="python--ex25_pycon.py-idio.html-13"></a><span class="n">sorted_words</span> <span class="o">=</span> <span class="n">ex25</span><span class="o">.</span><span class="n">sort_sentence</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio.html-14"></a><span class="n">sorted_words</span>
<a name="python--ex25_pycon.py-idio.html-15"></a><span class="n">ex25</span><span class="o">.</span><span class="n">print_first_and_last</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio.html-16"></a><span class="n">ex25</span><span class="o">.</span><span class="n">print_first_and_last_sorted</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
</pre></div>
</td></tr></table><p>Here's what it looks like when I work with the <tt class="docutils literal">ex25.py</tt> module in <tt class="docutils literal">python</tt>:</p>
<div class="highlight"><pre><span></span><a name="python--ex25_pycon.py-idio-pycon-pyg.html-1"></a><span class="go">Python 2.7.11 (default, Jan 22 2016, 23:30:40) </span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-2"></a><span class="go">[GCC 4.2.1 Compatible Apple LLVM 7.0.2 (clang-700.1.81)] on darwin</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-3"></a><span class="go">Type &quot;help&quot;, &quot;copyright&quot;, &quot;credits&quot; or &quot;license&quot; for more information.</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-4"></a><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">ex25</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-5"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">sentence</span> <span class="o">=</span> <span class="s2">&quot;All good things come to those who wait.&quot;</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-6"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">words</span> <span class="o">=</span> <span class="n">ex25</span><span class="o">.</span><span class="n">break_words</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-7"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">words</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-8"></a><span class="go">[&#39;All&#39;, &#39;good&#39;, &#39;things&#39;, &#39;come&#39;, &#39;to&#39;, &#39;those&#39;, &#39;who&#39;, &#39;wait.&#39;]</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-9"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">sorted_words</span> <span class="o">=</span> <span class="n">ex25</span><span class="o">.</span><span class="n">sort_words</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-10"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">sorted_words</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-11"></a><span class="go">[&#39;All&#39;, &#39;come&#39;, &#39;good&#39;, &#39;things&#39;, &#39;those&#39;, &#39;to&#39;, &#39;wait.&#39;, &#39;who&#39;]</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-12"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">ex25</span><span class="o">.</span><span class="n">print_first_word</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-13"></a><span class="go">All</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-14"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">ex25</span><span class="o">.</span><span class="n">print_last_word</span><span class="p">(</span><span class="n">words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-15"></a><span class="go">wait.</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-16"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">words</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-17"></a><span class="go">[&#39;good&#39;, &#39;things&#39;, &#39;come&#39;, &#39;to&#39;, &#39;those&#39;, &#39;who&#39;]</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-18"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">ex25</span><span class="o">.</span><span class="n">print_first_word</span><span class="p">(</span><span class="n">sorted_words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-19"></a><span class="go">All</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-20"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">ex25</span><span class="o">.</span><span class="n">print_last_word</span><span class="p">(</span><span class="n">sorted_words</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-21"></a><span class="go">who</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-22"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">sorted_words</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-23"></a><span class="go">[&#39;come&#39;, &#39;good&#39;, &#39;things&#39;, &#39;those&#39;, &#39;to&#39;, &#39;wait.&#39;]</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-24"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">sorted_words</span> <span class="o">=</span> <span class="n">ex25</span><span class="o">.</span><span class="n">sort_sentence</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-25"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">sorted_words</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-26"></a><span class="go">[&#39;All&#39;, &#39;come&#39;, &#39;good&#39;, &#39;things&#39;, &#39;those&#39;, &#39;to&#39;, &#39;wait.&#39;, &#39;who&#39;]</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-27"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">ex25</span><span class="o">.</span><span class="n">print_first_and_last</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-28"></a><span class="go">All</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-29"></a><span class="go">wait.</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-30"></a><span class="gp">&gt;&gt;&gt; </span><span class="n">ex25</span><span class="o">.</span><span class="n">print_first_and_last_sorted</span><span class="p">(</span><span class="n">sentence</span><span class="p">)</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-31"></a><span class="go">All</span>
<a name="python--ex25_pycon.py-idio-pycon-pyg.html-32"></a><span class="go">who</span>
</pre></div><p>As you go through each of these lines, make sure you can find the function that's being run in <tt class="docutils literal">ex25.py</tt> and you understand how each one works.  If you get different results or error, you'll have to go fix your code, exit <tt class="docutils literal">python</tt> and start over.</p>
</div>
<div class="section" id="study-drills">
<h1>Study Drills</h1>
<ol class="arabic simple">
<li>Take the remaining lines of the <em>What You Should See</em> output and figure out what they are doing.  Make sure you understand how you are running your functions in the <tt class="docutils literal">ex25</tt> module.</li>
<li>Try doing this:  <tt class="docutils literal">help(ex25)</tt> and also <tt class="docutils literal">help(ex25.break_words)</tt>.  Notice how you get help for your module, and how the help is those odd <tt class="docutils literal">&quot;&quot;&quot;</tt> strings you put after each function in ex25?  Those special strings are called <em>documentation comments</em> and we'll be seeing more of them.</li>
<li>Typing <tt class="docutils literal">ex25.</tt> is annoying.  A shortcut is to do your import like this:  <tt class="docutils literal">from ex25 import *</tt> which is like saying, &quot;Import everything from <tt class="docutils literal">ex25</tt>.&quot;  Programmers like saying things backward.  Start a new session and see how all your functions are right there.</li>
<li>Try breaking your file and see what it looks like in <tt class="docutils literal">python</tt> when you use it.  You will have to quit <tt class="docutils literal">python</tt> with <tt class="docutils literal">quit()</tt> to be able to reload it.</li>
</ol>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>I get <tt class="docutils literal">None</tt> printed out for some of the functions.</dt>
<dd>You probably have a function that is missing the <tt class="docutils literal">return</tt> at the end.  Go backward through the file and confirm that every line is right.</dd>
<dt>I get <tt class="docutils literal"><span class="pre">-bash:</span> import: command not found</tt> when I type <tt class="docutils literal">import ex25</tt>.</dt>
<dd>Pay attention to what I'm doing in the <em>What You Should See</em> section.  I'm doing this in <em>Python</em> not in the Terminal.  That means you first run Python.</dd>
<dt>I get <tt class="docutils literal">ImportError: No module named ex25.py</tt> when I type <tt class="docutils literal">import ex25.py</tt>.</dt>
<dd>Don't add the <tt class="docutils literal">.py</tt> to the end.  Python knows the file ends in <tt class="docutils literal">.py</tt> so you just type <tt class="docutils literal">import ex25</tt>.</dd>
<dt>I get <tt class="docutils literal">SyntaxError: invalid syntax</tt> when I run this.</dt>
<dd>That means you have something like a missing <tt class="docutils literal">(</tt> or <tt class="docutils literal">&quot;</tt> or similar syntax error on that line or above it.  Any time you get that error, start at the line it mentions and check that it's right, then go backward checking each line above that.</dd>
<dt>How can the <tt class="docutils literal">words.pop</tt> function change the <tt class="docutils literal">words</tt> variable?</dt>
<dd>That's a complicated question, but in this case <tt class="docutils literal">words</tt> is a list, and because of that you can give it commands and it'll retain the results of those commands.  This is similar to how files and many other things worked when you were working with them.</dd>
<dt>When should I <tt class="docutils literal">print</tt> instead of <tt class="docutils literal">return</tt> in a function?</dt>
<dd>The <tt class="docutils literal">return</tt> from a function gives the line of code that called the function a result.  You can think of a function as taking input through its arguments, and returning output through <tt class="docutils literal">return</tt>.  The <tt class="docutils literal">print</tt> is <em>completely</em> unrelated to this, and only deals with printing output to the terminal.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex25.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex25.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
